from pydantic import BaseModel

from gisaf.config import conf, Map, Measures, Geo
from gisaf.models.authentication import UserRead

class Proj(BaseModel):
    srid: str
    srid_for_proj: str


class BootstrapData(BaseModel):
    version: str = conf.version
    title: str = conf.gisaf.title
    windowTitle: str = conf.gisaf.windowTitle
    map: Map = conf.map
    geo: Geo = conf.geo
    measures: Measures = conf.measures
    redirect: str = conf.gisaf.redirect
    user: UserRead | None = None # type: ignore