from datetime import datetime

from sqlalchemy import BigInteger, String
from sqlmodel import Field

from gisaf.models.models_base import Model
from gisaf.models.metadata import gisaf_admin


class Reconciliation(Model):
    __table_args__ = gisaf_admin.table_args

    class Admin:
        menu = 'Other'
        flask_admin_model_view = 'ReconciliationModelView'

    id: int = Field(primary_key=True, sa_type=BigInteger,
                    sa_column_kwargs={'autoincrement': False})
    target: str = Field(sa_type=String(50))
    source: str = Field(sa_type=String(50))


class StatusChange(Model):
    __table_args__ = gisaf_admin.table_args
    __tablename__ = 'status_change'

    id: int = Field(primary_key=True, sa_type=BigInteger,
                    sa_column_kwargs={'autoincrement': False})
    store: str = Field(sa_type=String(50))
    ref_id: int = Field(sa_type=BigInteger())
    original: str = Field(sa_type=String(1))
    new: str = Field(sa_type=String(1))
    time: datetime


class FeatureDeletion(Model):
    __table_args__ = gisaf_admin.table_args
    __tablename__ = 'feature_deletion'

    id: int = Field(BigInteger, primary_key=True,
                    sa_column_kwargs={'autoincrement': False})
    store: str = Field(sa_type=String(50))
    ref_id: int = Field(sa_type=BigInteger())
    time: datetime